package ramsesTranslit;

import jsesh.editor.JMDCEditor;
import jsesh.mdc.MDCSyntaxError;
import jsesh.mdc.utils.MDCCodeExtractor;

import javax.imageio.ImageIO;
import javax.swing.*;

import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.client.fluent.*;

import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URI;
import java.net.http.HttpClient;
import java.net.http.HttpRequest;
import java.net.http.HttpResponse;
import java.net.http.HttpResponse.BodyHandlers;
import java.util.ArrayList;
import java.util.List;

public class JTranslitPanel extends JFrame {

	JMDCEditor mdcField = new JMDCEditor();
	JTextArea textArea = new JTextArea();
	JButton translitButton = new JButton("translit");
	JLabel attentionPanel = new JLabel();

	public JTranslitPanel() {
		JSplitPane splitPane0 = new JSplitPane(JSplitPane.VERTICAL_SPLIT, new JScrollPane(mdcField),
				new JScrollPane(textArea));
		JSplitPane splitPane1 = new JSplitPane(JSplitPane.VERTICAL_SPLIT, splitPane0, new JScrollPane(attentionPanel));
		splitPane0.setResizeWeight(0.5);
		splitPane1.setResizeWeight(0.75);
		JToolBar toolBar = new JToolBar();
		toolBar.add(translitButton);
		setLayout(new GridBagLayout());
		GridBagConstraints cc = new GridBagConstraints();
		cc.fill = GridBagConstraints.BOTH;
		cc.weightx = 1;
		cc.weighty = 1;
		add(splitPane1, cc);
		cc.fill = GridBagConstraints.HORIZONTAL;
		cc.weighty = 0;
		cc.gridy = 3;
		add(toolBar, cc);

		setSize(800, 600);
		setVisible(true);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		translitButton.addActionListener(e -> {
			textArea.setText("");
			SwingUtilities.invokeLater(() -> translitterate());
		});
	}

	public void translitterate() {
		try {
			MDCCodeExtractor codeExtractor = new MDCCodeExtractor();
			codeExtractor.setNormalize(true);
			codeExtractor.setSuppressNonGlyphs(true);
			List<String> res = codeExtractor.getCodesAsList(mdcField.getMDCText());
			String toSend = String.join(" ", res);

			String url = "http://localhost:8080/transliterate";
			String url1 = "http://localhost:8080/attention";
			
			Content returnContent = Request.Post(url).bodyForm(Form.form().add("mdc", toSend).build()).execute().returnContent();
			textArea.setText(returnContent.asString());
			Content pictureContent = 
				Request.Post(url1).bodyForm(Form.form().add("mdc", toSend).build())
					.execute().returnContent();			
			Icon icon = new ImageIcon(pictureContent.asBytes());
			attentionPanel.setIcon(icon);						
		} catch (MDCSyntaxError e) {
			e.printStackTrace();
		} catch (ClientProtocolException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public void setResult(final String txt) {
		SwingUtilities.invokeLater(() -> textArea.setText(txt));
	}

}