class Beam:
    """
    A simple beam. Inner algorithm is simple insertion sort,
    as the beam is somehow small.

    The beam with return the value with the MAXIMUM weight (best probability)
    """

    def __init__(self, width=5, content=[]):
        self.width= width
        self.t = content.copy()
    
    def add(self, priority, value):
        i = 0
        while i < len(self.t) and self.t[i][0] > priority:
            i += 1
        self.t.insert(i,(priority, value))
        if (len(self.t) > self.width):
            del(self.t[self.width:])

    def best_probability(self):
        """
        Returns the largest log-probability for a node
        """
        return self.t[0][0]

    def best_node(self):
        """
        Returns the node with the best weight
        """
        return self.t[0][1]

    def values(self):
        return self.t
    
    def copy(self):
        return Beam(self.width, self.t)

